{% extends 'proj/base.html' %}

{% comment %}Translation{% endcomment %}
{% load i18n %}

{% block scripts %}
{% load static %}

<script src="{% static 'dygraph.min.js' %}"></script>
<link rel="stylesheet" href="{% static 'dygraph.css' %}" type="text/css">
<link rel="stylesheet" href="{% static 'ol.css'%}" type="text/css">
<script src="{% static 'ol.js' %}"></script>

<style>
  /* Dygraphs */
  .dygraph-legend > span { display: none; }
  .dygraph-legend > span.highlight { display: inline; }
</style>

{% endblock %}

{% block headinfo %}


{% get_current_language as LANGUAGE_CODE %}
<!-- Current language: {{ LANGUAGE_CODE }} -->

<form id="topForm">
  <div class="drop"><img style="height:1em" src="{% static 'img/cloud-rain.svg' %}">
    {% trans 'parameter' %} : <span id="paramName" class="dropSelected">{{ default_metric }}</span>
    <ul class="ul-large">
      {% for c in catmetric %}
        <li class="category">{{ c }}</li>
        {% for m in c.get_ordered_metrics %}
          <li class="hoverable">
            <input type="radio" name="metric" id="metric{{ m.id }}" value="{{ m.id }}"
            {% if m == default_metric %}checked{% endif %}
            onchange="updateDrop('param', '{{ m }}')">
            <label for="metric{{ m.id }}">{{ m }}</label>
            {% if not m.monthly %}<span class="helptext" style="float:right;font-style:italic">{% trans 'per year only' %}</span>{% endif %}
          </li>
        {% endfor %}
      {% endfor %}
    </ul>
  </div>
  <div style="display:none" class="drop"><img style="height:1em" src="{% static 'img/list.svg' %}">
    {% trans 'models' %} : <span id="modelsNb" class="dropSelected">29</span>
    <ul class="ul-large">
      <li>
        <input type="checkbox" id="modelall" onchange="allModels(this.checked);" checked>
        <label for="modelall"><i>{% trans 'all models' %}</i></label>
        <p class="helptext">{% trans 'If unsure, it is best to keep all models selected.' %}</p>
        <div style="column-count:2">
          {% for m in models %}
            <input type="checkbox" value="{{ m.id }}" name="models" class="modelCheck" id="model{{ m.id }}" onchange="updateModelList()" checked>
            <label for="model{{ m.id }}">{{ m.name }}</label><br>
          {% endfor %}
        </div>
      </li>
      <li class="helptext" style="float:right"><a href="{% url 'proj:about' %}#models">{% trans 'more about models' %}</a></li>
    </ul>
  </div>
  <div class="drop"><img style="height:1em" src="{% static 'img/trending-up.svg' %}">
    {% trans 'map view' %} : <span id="scenName" class="dropSelected">{{ default_scenario }}</span>
    <ul class="ul-medium">
      {%for s in scenarii %}
        <li class="hoverable">
          <input value="{{ s.name }}" name="scenario" id="scen{{ s.id }}" type="radio" onchange="updateName('scen', '{{ s.name }}');updateMap(getArgs())"
          {% if s == default_scenario %}checked{% endif %}>
          <label for="scen{{ s.id }}">{{ s.name }} <span style="font-style:italic;color:gray">{{ s.locale_public_name }}</span></label>
        </li>
      {% endfor %}
      <li class="helptext" style="float:right"><a href="{% url 'proj:about' %}#scenarii">{% trans 'more about scenarii' %}</a></li>
    </ul>
  </div>
  <div class="drop"><img style="height:1em" src="{% static 'img/clock.svg' %}">
    {% trans 'period' %} : <span id="timeDisplay" class="dropSelected">{{ years }}</span>
    <ul class="ul-medium">
      <li style="display:none">
        {% trans 'Month(s)' %} : <input class="small-input" name="months" type="text" value="1-12" onchange="updateTime(this.form);">
      </li>
      <li>
        {% trans 'Year(s)' %} :
        <select name='years' onchange="updateTime(this.form)">
          <option>2011-2040</option>
          <option>2031-2060</option>
          <option selected>2051-2080</option>
          <option>2071-2100</option>
        </select>
      </li>
      <li class="hoverable" id="data">{% trans 'Compare' %} <span class="dropSelected" id="dataName">{% trans 'no comparison' %}</span>
        <ul style="width:100%;left:50%">
          <li class="hoverable">
            <input onchange="updateDrop('data', '{% trans 'raw data' %}');" value="data" type="radio" name="data" id="data1" checked>
            <label for="data1">{% trans 'no comparison' %}</label>
          </li>
          <li class="hoverable"><input onchange="updateDrop('data', '{% trans 'absolute difference' %}');" value="absolute" type="radio" name="data" id="data2">
            <label for="data2">{% trans 'absolute difference' %} (delta)</label>
          </li>
          <li class="hoverable">
            <input onchange="updateDrop('data', '{% trans 'relative difference' %}');" value="relative" type="radio" name="data" id="data3">
            <label for="data3">{% trans 'relative difference' %} (%)</label>
          </li>
        </ul>
        <li style="display:none" id="refYrWidget">
          <img alt=">" height='12' src="{% static 'svg/corner-down-right.svg' %}">
          {% trans 'with reference to' %} <input class="small-input" name="refYrs" value="{{ default_refyrs }}" type="text" onchange="updateAll()">
        </li>
    </ul>
  </div>
  <div class="drop">
    <img style="height:1em" src="{% static 'img/download.svg' %}">
    {% trans 'export' %}
    <ul class="ul-small">
      <li class="category">{% trans 'as image' %}</li>
      <li class="hoverable clickable" onclick="exportAll('png')">{% trans 'png (image)' %}</li>
      <li class="hoverable clickable" onclick="exportAll('svg')">{% trans 'svg (scalable vector)' %}</li>
      <li class="hoverable clickable" onclick="exportAll('pdf')">{% trans 'pdf (document)'%}</li>
      <li class="category">{% trans 'data only' %}</li>
      <li id="month_export">{% trans 'monthly' %} <a id="month_csv">csv</a> &middot; <a id="month_xls">xls</a></li>
      <li >{% trans 'yearly' %} <a id="year_csv">csv</a> &middot; <a id="year_xls">xls</a></li>
    </ul>
  </div>
</form>

{% endblock %}
{% block content %}




</div>

<div id="mapContainer">
    <div style="margin-left:10%;margin-right:10%;">
    <h3 style="text-align:center" id="mapTitle"></h3>
        <div>
            <!--
        <div class="drop clickable" onclick="zoomOut();">
            <img style="height:1em" src="{% static 'img/zoom-out.svg' %}"> {% trans 'reset view' %}
        </div>
        <div class="drop">
            <img style="height:1em" src="{% static 'img/crosshair.svg' %}">
            {% trans 'selection' %} : <span id="selectionName" class="dropSelected">region</span>
            <ul class="ul-small">
                <li class="hoverable"><input checked type="radio" name="selection" id="regionselection"
                                             onchange="updateSelect('region')">
                    <label for="regionselection">region</label></li>
                <li class="hoverable"><input type="radio" name="selection" id="pixelselection"
                                             onchange="updateSelect('pixel')">
                    <label for="pixelselection">pixel</label></li>
                <li class="hoverable"><input type="radio" name="selection" id="stationselection"
                                             onchange="updateSelect('station')">
                    <label for="stationselection">station</label></li>
            </ul>
        </div>-->
        </div>
    </div>
    <div id="map" style="height:100%;"></div>
    <div id="newscale" style="display:block; position:absolute; top:100px; right:5px;">
        <table class="scaleTable">
            <tr>
                <td class="helptext" id="scale8">0</td>
                <td class="scaleO" id="scale8c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale7">0</td>
                <td class="scaleO" id="scale7c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale6">0</td>
                <td class="scaleO" id="scale6c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale5">0</td>
                <td class="scaleO" id="scale5c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale4">0</td>
                <td class="scaleO" id="scale4c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale3">0</td>
                <td class="scaleO" id="scale3c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale2">0</td>
                <td class="scaleO" id="scale2c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale1">0</td>
                <td class="scaleO" id="scale1c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale0">0</td>
                <td class="scaleO" id="scale0c">&nbsp;</td>
            </tr>
        </table>

    </div>
    <div id="error"></div>
    <!--
    <div style="position:absolute;top:100px;left:20px" class="mapoverlay">
        <div class="drop clickable" onclick="zoomOut();">
            <img style="height:1em" src="{% static 'img/zoom-out.svg' %}"> {% trans 'reset view' %}
        </div>
        <div class="drop">
            <img style="height:1em" src="{% static 'img/crosshair.svg' %}">
            {% trans 'selection' %} : <span id="selectionName" class="dropSelected">region</span>
            <ul class="ul-small">
                <li class="hoverable"><input checked type="radio" name="selection" id="regionselection"
                                             onchange="updateSelect('region')">
                    <label for="regionselection">region</label></li>
                <li class="hoverable"><input type="radio" name="selection" id="pixelselection"
                                             onchange="updateSelect('pixel')">
                    <label for="pixelselection">pixel</label></li>
                <li class="hoverable"><input type="radio" name="selection" id="stationselection"
                                             onchange="updateSelect('station')">
                    <label for="stationselection">station</label></li>
            </ul>
        </div>
    </div>
    <div id="maphelp" class="helptext">
        <img id="maphelphidden" style="display:none;position:absolute;left:100%;top:0" onclick="toggleMapHelp(true)"
             src="{% static 'img/plus-circle.svg' %}">
        <div id="maphelpvisible" class="mapoverlay">
            <img class="mapoverlay" style="position:absolute;left:100%;top:0" onclick="toggleMapHelp(false)"
                 src="{% static 'img/x-circle.svg' %}">

            <ul>{% blocktrans trimmed %}
                <li>Data is aggregated by <span
                        id="agg" style="font-weight:bold"></span> for each year,
                    then <b>averaged</b> for years, regions and climate models.
                </li>
                <li><i>Click</i> on a region for specific data.
                    <i>Click-and-drag</i> to select multiple regions at once, <i>shift-click</i> to add or remove a
                    region from
                    selection.
                </li>
                <li><i>Alt-click</i> displays data for a specific location (a bit slower, but more precise calculation
                    especially for large regions).
                </li>
                <li>Click outside of any region to <a style="cursor:pointer" onclick='zoomOut()'>zoom out to Senegal</a>.
                </li>
                {% endblocktrans %}
            </ul>
        </div>
    </div>
    -->
    <p id="mapinfo" class="mapoverlay"></p>
</div>
<div id="rightPanel">
    <form id="chartForm">
        <div class="legend">
            <div class="drop" style="display:none">
                {% trans 'compare' %} <span id="ZcompareName" class="dropSelected">{% trans compare %}</span>
                <ul style="min-width:150px;">
                    <li class="hoverable">
                        <input onchange="updateDrop('Zcompare', '{% trans 'scenarii' %}')" type="radio"
                               name="compare"
                               id="Zcompare1"
                               value="scenarii"
                               {% if compare == 'scenarii' %}checked{% endif %}>
                        <label for="Zcompare1">{% trans 'scenarii' %}</label>
                    </li>
                    <li class="hoverable"><input onchange="updateDrop('Zcompare', '{% trans 'models' %}')" type="radio"
                                                 name="compare"
                                                 id="Zcompare2"
                                                 value="models" {% if compare == 'models' %}checked{% endif %}>
                        <label for="Zcompare2">{% trans 'models' %}</label></li>
                </ul>
            </div>
            <div id="graphLegend" style="margin-top:20px"></div>
        </div>
    </form>
    <div class="chartContainer" id="monthChartContainer">
        <div id="monthUnit" style="position:absolute;top:30px;left:60px" class="helptext"></div>
        <div class="chart" id="monthChart"></div>
    </div>
    <div class="chartContainer">
        <div id="yearUnit" style="position:absolute;top:30px;left:60px" class="helptext"></div>
        <div class="chart" id="yearChart"></div>
    </div>
    <p class="helptext" style="text-align:center;">{% blocktrans trimmed %}The shaded zone in scenario view is the error bar
        (i.e. standard deviation of available models).<br>
        Drag-and-click to zoom on bottom chart. Double-click
        to reset. <a style="cursor:pointer" onclick="useRangeBounds()">Use these bounds</a>
        <br>Bottom-left box sets rolling average. <a id="permalink">Get permalink</a>.{% endblocktrans %}</p>
</div>

<script src="{% static 'stations.js' %}"></script>
<script src="{% static 'proj.js' %}"></script>
{% get_current_language as LANGUAGE_CODE %}
{% if LANGUAGE_CODE == "fr" %}
<!-- overwrite some functions -->
<script src="{% static 'proj_fr.js' %}"></script>
{% endif %}

<script type="text/javascript">

background.setSource(new ol.source.Vector({
        format: new ol.format.GeoJSON(),
        url: "{% static 'fond.geojson' %}"
    }));

stations.setSource(new ol.source.Vector({
            features: (new ol.format.GeoJSON()).readFeatures({{ stations|safe }}),
            projection: 'EPSG:4326'
	}));

var values, scale,
    graph_color = {{ graph_color|safe }},
    metric = {{ default_metric.to_dict|safe }},
    thisUrl = "{% url 'proj:index' %}";


regions.setSource(new ol.source.Vector({
            features: (new ol.format.GeoJSON()).readFeatures({{ regions|safe }}),
            projection: 'EPSG:4326'
}));

var places = new ol.layer.Vector({
	source: new ol.source.Vector({
            features: (new ol.format.GeoJSON()).readFeatures({{ places|safe }}),
            projection: 'EPSG:4326',
	}),
	zIndex: 100,
	style: textStyle,
	map: mymap /* only way to set z-index to +Infinity */
    });

mymap.addLayer(places);

var monthlyMetrics = {{ monthly_metrics|safe }};


{% if args %}
var args = "{{ args|safe }}";
{% else %}
var args = getArgs();
{% endif %}
updateMap(args);
updateGraphs(args);

var img_X = "{% static 'img/x-circle.svg' %}",
    img_eye = "{% static 'img/eye.svg' %}",
    img_eye_off = "{% static 'img/eye-off.svg' %}",
    img_toggle = "{% static 'img/refresh-cw.svg' %}";

</script>
{% endblock %}
